Bump version to 2.5.5rc1.
[rsync/rsync.git] / testsuite / rsync.fns
CommitLineData
d820215b
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
3a4c683f 6
0154b302
MP
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
3a4c683f
MP
21TMP="$scratchdir"
22FROM=${TMP}/from
23TO=${TMP}/to
3a4c683f 24LOG=${TMP}/log
3fedd74b 25RSYNC="$rsync_bin"
3a4c683f 26
2094283b 27# Berkley's nice.
96553aa7 28PATH="$PATH:/usr/ucb"
2094283b 29
3a4c683f
MP
30runtest() {
31 echo $ECHO_N "Test $1: $ECHO_C"
501972bf
MP
32 if eval "$2"
33 then
34 echo "${ECHO_T} done."
35 return 0
36 else
37 echo "${ECHO_T} failed!"
38 return 1
39 fi
3a4c683f
MP
40}
41
42printmsg() {
43 echo "$1"
44}
45
e052b21f 46
6773a779 47rsync_ls_lR() {
dfef3f10
MP
48 find "$@" -print | sort | xargs "$TOOLDIR/tls"
49}
50
51rsync_getgroups() {
52 "$TOOLDIR/getgroups"
57835c00
MP
53}
54
55
e052b21f
MP
56####################
57# Build test directories TO and FROM, with FROM full of files.
58
3a4c683f 59hands_setup() {
501972bf
MP
60 # Clean before creation
61 rm -rf $FROM
62 rm -rf $TO
3d807132
MP
63
64 [ -d $TMP ] || mkdir $TMP
3a4c683f
MP
65 [ -d $FROM ] || mkdir $FROM
66 [ -d $TO ] || mkdir $TO
67
e052b21f
MP
68 # On some BSD systems, the umask affects the mode of created
69 # symlinks, even though the mode apparently has no effect on how
70 # the links behave in the future, and it cannot be changed using
71 # chmod! rsync always sets its umask to 000 so that it can
72 # accurately recreate permissions, but this script is probably run
73 # with a different umask.
74
75 # This causes a little problem that "ls -l" of the two will not be
76 # the same. So, we need to set our umask before doing any creations.
77
3a4c683f
MP
78 # set up test data
79 touch ${FROM}/empty
80 mkdir ${FROM}/emptydir
e8ca5901 81
571a4b26 82 # a hundred lines of text or so
3d807132 83 rsync_ls_lR "${srcdir}" > ${FROM}/filelist
3a4c683f
MP
84
85 # This might fail on systems that don't have -n
86 echo $ECHO_N "This file has no trailing lf$ECHO_C" > ${FROM}/nolf
0154b302 87 umask 0
3a4c683f 88 ln -s nolf ${FROM}/nolf-symlink
4c80c473 89 umask 022
0154b302 90
4c80c473 91 cat $srcdir/*.c > ${FROM}/text
3a4c683f 92 mkdir ${FROM}/dir
4c80c473 93 cp ${FROM}/text ${FROM}/dir
3a4c683f
MP
94 mkdir ${FROM}/dir/subdir
95 mkdir ${FROM}/dir/subdir/subsubdir
96 ls -ltr /etc > ${FROM}/dir/subdir/subsubdir/etc-ltr-list
97 mkdir ${FROM}/dir/subdir/subsubdir2
98 ls -lt /bin > ${FROM}/dir/subdir/subsubdir2/bin-lt-list
7d691654 99
8f98c608
MP
100# echo testing head:
101# ls -lR ${srcdir} | head -10 || echo failed
3a4c683f 102}
3fedd74b
MP
103
104
3d807132
MP
105hands_cleanup() {
106 rm -r "$TMP"
107}
108
109
e052b21f 110
99cdaff7
MP
111
112####################
113# Many machines do not have "mkdir -p", so we have to build up long paths.
114# How boring.
115makepath () {
7c1b7890 116 echo " makepath $1"
99cdaff7
MP
117 p="$1"
118 (
119 # Absolut Unix.
120 if echo $p | grep '^/' >/dev/null
121 then
122 cd /
123 fi
124
125 # This will break if $1 contains a space.
126 for c in `echo $p | tr '/' ' '`
127 do
112e7311
MP
128 if [ -d "$c" ] || mkdir "$c"
129 then
130 cd "$c" || return $?
131 else
132 echo "failed to create $c" >&2; return $?
133 fi
99cdaff7
MP
134 done
135 )
136}
137
138
139
3fedd74b
MP
140###########################
141# Run a test (in '$1') then compare directories $2 and $3 to see if
142# there are any difference. If there are, explain them.
143
f494f286
MP
144# So normally basically $1 should be an rsync command, and $2 and $3
145# the source and destination directories. This is only good when you
146# expect to transfer the whole directory exactly as is. If some files
147# should be excluded, you might need to use something else.
148
3fedd74b 149checkit() {
3fedd74b 150 failed=
3fedd74b 151
cf72f204
MP
152 # We can just write everything to stdout/stderr, because the
153 # wrapper hides it unless there is a problem.
154
155 echo "Running: \"$1\""
156 eval "$1"
3fedd74b
MP
157 status=$?
158 if [ $status != 0 ]; then
159 failed="YES";
160 fi
161
cf72f204
MP
162 echo "-------------"
163 echo "check how the files compare with diff:"
164 echo ""
d58e4c27
MP
165 for f in `cd "$2"; find . -type f -print `
166 do
371d1c36 167 diff -c "$2"/"$f" "$3"/"$f" || failed=YES
d58e4c27
MP
168 done
169
cf72f204
MP
170 echo "-------------"
171 echo "check how the directory listings compare with diff:"
172 echo ""
173 ( cd "$2" && rsync_ls_lR . ) > ${TMP}/ls-from
174 ( cd "$3" && rsync_ls_lR . ) > ${TMP}/ls-to
175 diff -c ${TMP}/ls-from ${TMP}/ls-to || failed=YES
3fedd74b 176 if [ -z "${failed}" ] ; then
3fedd74b
MP
177 return 0
178 else
3fedd74b
MP
179 return 1
180 fi
181}
182
863dff51
MP
183
184# In fact, we need a more general feature of capturing all stderr/log files,
185# and dumping them if something goes wrong.
186
187checkforlogs() {
188 # skip it if we're under debian-test
189 if test -n "${Debian}" ; then return 0 ; fi
190
191 if [ -f $1 -a -s $1 ] ; then
192 echo "Failures have occurred. $1 follows:" >&2
193 cat $1 >&2
194 exit 1
195 fi
196}
197
d2094cc3 198
4a7cb3e8 199build_rsyncd_conf() {
d2094cc3
MP
200 # Build an appropriate configuration file
201 conf="$scratchdir/test-rsyncd.conf"
202 echo "building configuration $conf"
203
204 port=2612
205 pidfile="$scratchdir/rsyncd.pid"
206 logfile="$scratchdir/rsyncd.log"
207
208 cat >$conf <<EOF
3aae15ec 209# rsyncd configuration file autogenerated by $0
d2094cc3 210
3aae15ec
MP
211pid file = $pidfile
212use chroot = no
213hosts allow = localhost, 127.0.0.1
214log file = $logfile
d2094cc3 215
98c1b325
MP
216# We don't know if this machine has "nobody" or "nogroup", so use the quasi-canonical
217# values of (uint16_t) -2.
218
219uid = 65534
220gid = 65534
221
2e6c7f45
MP
222[test-from]
223 path = $FROM
3aae15ec 224 read only = yes
d2094cc3 225
2e6c7f45
MP
226[test-to]
227 path = $TO
3aae15ec 228 read only = no
d2094cc3
MP
229EOF
230}
231
232
3cd2af41
MP
233build_symlinks() {
234 fromdir="$scratchdir/from"
235 todir="$scratchdir/to"
236 mkdir "$fromdir"
237 date >"$fromdir/referent"
238 ln -s referent "$fromdir/relative"
239 ln -s "$fromdir/referent" "$fromdir/absolute"
240 ln -s nonexistent "$fromdir/dangling"
1db8b61d 241 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
3cd2af41
MP
242}
243
244test_fail() {
245 echo "$@" >&2
246 exit 1
247}
248
a217ad30
MP
249test_skipped() {
250 echo "$@" >&2
7d821932 251 echo "$@" > "$TMP/whyskipped"
a217ad30
MP
252 exit 77
253}
254
be2f866b
MP
255# It failed, but we expected that. don't dump out error logs,
256# because most users won't want to see them. But do leave
257# the working directory around.
258test_xfail() {
259 echo "$@" >&2
260 exit 78
261}
262
d96d3893
MP
263# Test whether something is a link, allowing for shell peculiarities
264is_a_link() {
265 test -L "$1" || test -h "$1" || /usr/bin/test -L "$1" || /usr/bin/test -h "$1"
266}
267
77867907
MP
268
269# We need to set the umask to be reproducible. Note also that when we
270# do some daemon tests as root, we will setuid() and therefore the
271# directory has to be writable by the nobody user in some cases. The
272# best thing is probably to explicitly chmod those directories after
273# creation.
274
275umask 022